from typing import Any, Dict, List, Type, TypeVar

import attr

T = TypeVar("T", bound="GetConnectionStringResponseParams")


@attr.s(auto_attribs=True)
class GetConnectionStringResponseParams:
    """params contains a list of individual key parameters for generating nonstandard connection strings."""

    additional_properties: Dict[str, str] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        get_connection_string_response_params = cls()

        get_connection_string_response_params.additional_properties = d
        return get_connection_string_response_params

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> str:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: str) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
